#include <stdio.h>
#include <Windows.h>

typedef enum color {
	BLACK, DARK_BLUE, DARK_GREEN, DARK_SKY_BLUE,
	DARK_RED, DARK_PURPLE, DARK_YELLOW, GRAY,
	DARK_GRAY, BLUE, GREEN, SKY_BlUE,
	RED, PURPLE, YELLOW, WHITE
} color;

void setColor(color background, color text);
void gotoxy(int x, int y);

int main()
{
	// 1은 하얀색, 0은 검정색
	int picture[5][5] = {
		{ 1, 1, 1, 1, 1 },
		{ 1, 0, 0, 0, 1 },
		{ 1, 0, 1, 0, 1 },
		{ 1, 0, 0, 0, 1 },
		{ 1, 1, 1, 1, 1 }
	};

	for (int i = 0; i < 5; i++)
	{
		for (int j = 0; j < 5; j++)
		{
			// 배열의 값에 따라 색을 설정한다.
			if (picture[i][j] == 0)
				setColor(BLACK, BLACK);
			else
				setColor(WHITE, WHITE);
			gotoxy(j * 2, i); // 색을 칠할 위치로 이동한다.
			printf("  "); // 두 칸을 칠한다.
		}
	}

	// 그림이 훼손되지 않는 위치로 이동하여 마무리한다.
	gotoxy(0, 5);
	setColor(BLACK, WHITE);
}

void setColor(color background, color text)
{
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), background * 16 + text);
}

void gotoxy(int x, int y)
{
	COORD pos = { x, y };
	SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), pos);
}