#include <Windows.h>
#include <windowsx.h>
#include <stdio.h>
#pragma warning(disable: 4996)

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
HWND createWindow(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow);
HWND createButton(HWND parent, int x, int y, int width, int height, const wchar_t* text, int id);
HWND createText(HWND parent, int x, int y, int width, int height, const wchar_t* text);

void keyboardEvt(wchar_t ch); // 키보드 입력 함수
void save(); // 저장 함수

HWND hWnd, text, button;
wchar_t str[1024]; // 입력한 문자열을 저장할 변수
int len = 0; // 현재 문자열의 길이

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    hWnd = createWindow(hInstance, hPrevInstance, lpCmdLine, nCmdShow);
    text = createText(hWnd, 10, 10, 460, 100, L"");
    button = createButton(hWnd, 10, 120, 460, 30, L"저장", 1);

    MSG msg = { 0 };
    while (GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return (int)msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
    case WM_COMMAND:
        if (LOWORD(wParam) == 1)
            save(); // 저장 버튼을 누르면 save 함수를 호출한다.
        break;
    case WM_CHAR:
        keyboardEvt((wchar_t)wParam); // 키보드를 누르면 keyboardEvt 함수를 호출한다.
        break;
    case WM_DESTROY:
        PostQuitMessage(0);
        break;
    default:
        return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}

HWND createWindow(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    WNDCLASS wc = { 0 };
    wc.lpfnWndProc = WndProc;
    wc.hInstance = hInstance;
    wc.hbrBackground = (HBRUSH)(COLOR_BACKGROUND);
    wc.lpszClassName = TEXT("MyWindowClass");
    RegisterClass(&wc);

    HWND hWnd = CreateWindow(
        TEXT("MyWindowClass"),
        TEXT("Window Title"),
        WS_OVERLAPPEDWINDOW,
        100,
        100,
        500,
        200,
        NULL,
        NULL,
        hInstance,
        NULL
    );
    ShowWindow(hWnd, nCmdShow);

    return hWnd;
}

HWND createButton(HWND parent, int x, int y, int width, int height, const wchar_t* text, int id)
{
    HWND hWnd = CreateWindow(
        L"BUTTON",
        text,
        WS_TABSTOP | WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,
        x,
        y,
        width,
        height,
        parent,
        id,
        (HINSTANCE)GetWindowLongPtr(parent, GWLP_HINSTANCE),
        NULL);
    ShowWindow(hWnd, 1);

    return hWnd;
}

HWND createText(HWND parent, int x, int y, int width, int height, const wchar_t* text)
{
    HWND hWnd = CreateWindow(
        L"STATIC",
        text,
        SS_CENTER | WS_CHILD,
        x,
        y,
        width,
        height,
        parent,
        NULL,
        (HINSTANCE)GetWindowLongPtr(parent, GWLP_HINSTANCE),
        NULL);
    ShowWindow(hWnd, 1);

    return hWnd;
}

void keyboardEvt(wchar_t ch)
{
    str[len] = ch; // 새로운 글자를 문자열 마지막에 추가한다.
    str[len + 1] = L'\0'; // 마지막에 널 문자를 추가한다.
    len++; // 길이를 증가시킨다.
    SetWindowText(text, str); // 갱신된 str을 텍스트에 출력한다.
}

void save()
{
    FILE* fp = fopen("./out.txt", "w"); // 파일을 연다.
    fprintf(fp, "%S", str); // 문자열의 모든 내용을 파일에 쓴다. wchar_t이므로 형식 지정자는 %S이다.
    fclose(fp); // 파일을 닫는다.

    str[0] = L'\0'; // 첫 인덱스를 널 문자로 만들어 문자열을 초기화시킨다.
    len = 0; // 길이를 0으로 만든다.
    SetWindowText(text, str); // 갱신된 str을 텍스트에 출력한다.
}