#include <stdio.h>
#include <stdlib.h>

typedef struct node {
	int value;
	struct node* next;
} node;

typedef struct list {
	struct node* head;
	int size;
} list;

list* init();
void appendFirst(list* li, int value);
void removeFirst(list* li);
void appendLast(list* li, int x); // 함수의 선언 

int main()
{
	list* li = init();

	appendFirst(li, 1);
	appendFirst(li, 2);
	appendFirst(li, 3);
	appendLast(li, 4);

	for (node* now = li->head; now; now = now->next)
		printf("%d\n", now->value);

	for (node* now = li->head; now;)
	{
		node* next = now->next;
		free(now);
		now = next;
	}
}

void appendLast(list* li, int x)
{
	if (li->head == NULL) // 연결 리스트가 비어있다면
	{
		// 값을 바로 추가한다.
		li->head = malloc(sizeof(node));
		li->head->next = NULL;
		li->head->value = x;
	}
	else // 비어있지 않다면
	{
		// 마지막 노드까지 순회하여 cur에 저장한다.
		node* cur = li->head;
		while (cur->next != NULL)
			cur = cur->next;

		// cur에 새로운 노드를 붙인다.값을 바로 추가한다.
		cur->next = malloc(sizeof(node));
		cur->next->next = NULL;
		cur->next->value = x;
	}
	li->size++;
}

list* init()
{
	list* li = malloc(sizeof(list));
	li->head = NULL;
	li->size = 0;
	return li;
}

void appendFirst(list* li, int value)
{
	node* first = malloc(sizeof(node));
	node* second = li->head;

	first->value = value;
	first->next = second;
	li->head = first;
	li->size++;
}

void removeFirst(list* li)
{
	if (li->size > 0)
	{
		node* first = li->head->next;
		free(li->head);
		li->head = first;
		li->size--;
	}
}