#include <stdio.h>
#include <stdlib.h>

typedef struct array {
	int* data;
	int size, capacity;
} array;

array* init();
void append(array* v, int value);
int* index(array* v, int i);
void removeIdx(array* v, int i); // 함수의 선언

int main()
{
	array* v = init();
	append(v, 1);
	append(v, 2);
	append(v, 3);
	removeIdx(v, 1);

	for (int i = 0, *p = index(v, 0); p; i++, p = index(v, i))
		printf("%d\n", *p);

	free(v->data);
	free(v);
}

void removeIdx(array* v, int i)
{
	for (i++; i < v->size; i++) // i + 1부터 size-1까지 반복한다.
		v->data[i - 1] = v->data[i]; // 한 칸 왼쪽으로 당긴다.
	v->size--; // 크기를 하나 감소시킨다.
}

array* init()
{
	array* v = malloc(sizeof(array));
	v->data = malloc(sizeof(int) * 2);
	v->size = 0;
	v->capacity = 2;
	return v;
}

void append(array* v, int value)
{
	if (v->size == v->capacity)
	{
		v->capacity *= 2;
		int* newData = malloc(sizeof(int) * v->capacity);
		for (int i = 0; i < v->size; i++)
			newData[i] = v->data[i];
		free(v->data);
		v->data = newData;
	}
	v->data[v->size] = value;
	v->size++;
}

int* index(array* v, int i)
{
	if (v->size <= i)
		return NULL;
	return v->data + i;
}